function output=PutTogetherAdvanced(edge1,edge2,piece1,piece2,edge1Index,edge2Index)

%TEST IF LENGTH OF THE EDGES IS SIGNIFICANTLY DIFFERENT
distances = zeros(2,1);
for i=2:length(edge1(:,1))
    distances(1) = sqrt((edge1(i,1)-edge1(i-1,1))^2+(edge1(i,2)-edge1(i-1,2))^2+(edge1(i,3)-edge1(i-1,3))^2)+distances(1);
    distances(2) = sqrt((edge2(i,1)-edge2(i-1,1))^2+(edge2(i,2)-edge2(i-1,2))^2+(edge2(i,3)-edge2(i-1,3))^2)+distances(2);
end
distances = sort(distances);

%TRANSFORMATION MATRICES
rigidTransformation1 = estimateRigidTransform(edge1',fliplr(edge2'));
rotationMatrix1      = rigidTransformation1(1:3,1:3);
translantion1        = rigidTransformation1(1:3,4);

rigidTransformation2 = estimateRigidTransform(edge1',edge2');
rotationMatrix2      = rigidTransformation2(1:3,1:3);
translation2         = rigidTransformation2(1:3,4);

%ROTATING PIECES
shiftedPiece2a = zeros(length(piece2),3);
shiftedPiece2b = zeros(length(piece2),3);
for a=1:length(piece2)
    shiftedPiece2a(a,:)=(rotationMatrix1*(piece2(a,:))'+translantion1)';
end
for a=1:length(piece2)
    shiftedPiece2b(a,:)=(rotationMatrix2*(piece2(a,:))'+translation2)';
end

%DETERMINING BETTER ROTATION MATRIX
shiftedEdge2a = zeros(length(edge2),3);
shiftedEdge2b = zeros(length(edge2),3);
for j=1:length(edge2(:,1))
    shiftedEdge2a(j,:)=(rotationMatrix1*(edge2(j,:))'+translantion1)';
end
for j=1:length(edge2(:,1))
    shiftedEdge2b(j,:)=(rotationMatrix2*(edge2(j,:))'+translation2)';
end

edgeHaus(1) = HausdorffDist(edge1,shiftedEdge2a);
edgeHaus(2) = HausdorffDist(edge1,shiftedEdge2b);

%DETERMINING CONCAVITY/CONVEXITY OF EDGES
projectedPiece1                                  = rotate(piece1);
totalArea1                                       = polyarea(projectedPiece1(:,1),projectedPiece1(:,2));
projectedPiece1(edge1Index(1):edge1Index(end),:) = [];
partionedArea1                                   = polyarea(projectedPiece1(:,1),projectedPiece1(:,2));

if totalArea1<partionedArea1
    out1 = 1;
else 
    out1 = -1;
end

projectedPiece2                                  = rotate(shiftedPiece2a);
totalArea2                                       = polyarea(projectedPiece2(:,1),projectedPiece2(:,2));
projectedPiece2(edge2Index(1):edge2Index(end),:) = [];
partionedArea2                                   = polyarea(projectedPiece2(:,1),projectedPiece2(:,2));

if totalArea2<partionedArea2
    out2 = 1;
else 
    out2 = -1;
end

%OUTPUT
if HausdorffDist(edge1,shiftedEdge2a)>0.07 || out1==out2
%     fprintf('FAIL: THE HAUS IS %f, RATIO IS %f, AND OTHER FIT IS %f\n',edgeHaus(1),distances(1)/distances(2),edgeHaus(2));
%     disp(edgeHaus(2)/edgeHaus(1));
%     figure(5); hold on
%     plot3(piece1(:,1),piece1(:,2),piece1(:,3),'k','LineWidth',2);
%     plot3(shiftedPiece2a(:,1),shiftedPiece2a(:,2),shiftedPiece2a(:,3),'LineWidth',2);
%     plot3(edge1(:,1),edge1(:,2),edge1(:,3),'.g','LineWidth',2);
%     plot3(shiftedEdge2a(:,1),shiftedEdge2a(:,2),shiftedEdge2a(:,3),'.r','LineWidth',2);
    
    output ='w';
else
%     fprintf('PASS: THE HAUS IS %f, RATIO IS %f, AND OTHER FIT IS %f\n',edgeHaus(1),distances(1)/distances(2),edgeHaus(2));
%     figure(5); hold on
%     plot3(piece1(:,1),piece1(:,2),piece1(:,3),'k','LineWidth',2);
%     plot3(shiftedPiece2a(:,1),shiftedPiece2a(:,2),shiftedPiece2a(:,3),'LineWidth',2);
%     plot3(edge1(:,1),edge1(:,2),edge1(:,3),'.g','LineWidth',2);
%     plot3(shiftedEdge2a(:,1),shiftedEdge2a(:,2),shiftedEdge2a(:,3),'.r','LineWidth',2);
    output = rigidTransformation1;
end
% output = rigidTransformation1;
% %PLOTTING PIECES
% figure(5); hold on
% plot3(piece1(:,1),piece1(:,2),piece1(:,3),'k','LineWidth',2);
% plot3(shiftedPiece2a(:,1),shiftedPiece2a(:,2),shiftedPiece2a(:,3),'LineWidth',2);
% plot3(edge1(:,1),edge1(:,2),edge1(:,3),'.g','LineWidth',2);
% plot3(shiftedEdge2a(:,1),shiftedEdge2a(:,2),shiftedEdge2a(:,3),'.r','LineWidth',2);

% figure(2); hold on
% plot3(piece1(:,1),piece1(:,2),piece1(:,3),'k','LineWidth',2);
% plot3(p2b(:,1),p2b(:,2),p2b(:,3),'LineWidth',2);
% plot3(c1(:,1),c1(:,2),c1(:,3),'.r','LineWidth',2);
end

%%
