function newvertmat=rotate(in)

vertmat=in;
% Here we compute a point (centroid) and normal vector (normal) for the 
% for our LSP that we will shift to the origin and then rotate.
centroid = mean(vertmat);
centeredvert = vertmat - repmat(centroid,size(vertmat,1),1);
% Normal vector is principle eigenvector of covariance matrix
[normal, LAMBDA] = eig(cov(centeredvert));
[~,idx] = min(diag(LAMBDA));
% And normalize
normal = normal(:,idx)./norm(normal(:,idx));
normal = normal';

% Find a rotation matrix rot that will transform the normal vector so 
% that it is parallel to z axis.

k = [0 0 1];

kxV = cross(k, normal);
kxV = kxV/norm(kxV);
theta = acos(dot(normal, k));

s = sin(theta);
c = cos(theta);
t = 1 - c;

x = kxV(1);
y = kxV(2);
z = kxV(3);

% The matrix rot satisfies normal*rot = k

rot = [t*x*x + c,    t*x*y - s*z,  t*x*z + s*y;
     t*x*y + s*z,  t*y*y + c,    t*y*z - s*x;
     t*x*z - s*y,  t*y*z + s*x,  t*z*z + c];

newvertmat = centeredvert*rot;

% figure(1); 
% plot3(in(:,1),in(:,2),in(:,3));
% figure(2);
% plot3(newvertmat(:,1),newvertmat(:,2),newvertmat(:,3));
% plot(newvertmat(:,1),newvertmat(:,2));

end