%INPUT IS A PUZZLE

function out = NoisySolver(x)

%SCRAMBLER
for h=1:length(x)
    x{h,1} = scrambler3d(x{h,1});
end

%SEGMENTING
fprintf('SEGMENTING\n');
puzzle = KappaSegmentation(x);

% figure(1); hold on
% for i=1:length(x)
% plot3(puzzle(i).piece(:,1),puzzle(i).piece(:,2),puzzle(i).piece(:,3),'r','LineWidth',2);
% end

%CALCULATING SIMILARITY SCORE
%score is stored so that first entry is matching piece, second is matching
%edge, and third entry is the similarity score
fprintf('SKEWNESS CALCULATION\n');
num = 0;
for h=1:length(x) %SET PIECE
    if (isempty(puzzle(h).edge))
        continue
    end
    for j=1:length(puzzle(h).edge(:,1)) %SET EDGE
        cnt = 0;
        for k=1:length(x) %COMPARATIVE PIECE
            if h==k
                continue
            end
            if isempty(puzzle(k).edge)
                continue
            end
            
            %ARC LENGTH OF SET EDGE
            distances = zeros(1,2);
            for m=2:length(puzzle(h).edge{j,1}(:,1))
                distances(1) = sqrt((puzzle(h).edge{j,1}(m,1)-puzzle(h).edge{j,1}(m-1))^2+ ...
                    (puzzle(h).edge{j,1}(m,2)-puzzle(h).edge{j,1}(m-1,2))^2+ ...
                    (puzzle(h).edge{j,1}(m,3)-puzzle(h).edge{j,1}(m-1,3))^2)+ distances(1);
            end
            
            for m=1:length(puzzle(k).edge(:,1)) %COMPARATIVE EDGE
                %LENGTH OF COMPARATIVE EDGE
                distances(2) = 0;
                for n=2:length(puzzle(h).edge{j,1}(:,1))
                    distances(2) = sqrt((puzzle(k).edge{m,1}(n,1)-puzzle(k).edge{m,1}(n-1))^2+ ...
                        (puzzle(k).edge{m,1}(n,2)-puzzle(k).edge{m,1}(n-1,2))^2+ ...
                        (puzzle(k).edge{m,1}(n,3)-puzzle(k).edge{m,1}(n-1,3))^2)+distances(2);
                end
                
                %DETERMINING WHETHER TO CALCULATE SIMILARITY BETWEEN EDGES
                if min(distances)/max(distances)<0.8 
                    skew = 10;
                else          

                     skew = compareEgg3DEXP(puzzle(k).edge{m,2},puzzle(h).edge{j,2});
                    
                    %EHHHH NOT WORKING YET
%                     if distances(1)<distances(2)
%                         [sig1, sig2] = RedistributePointsSig(puzzle(h).edge{j,1},puzzle(h).edge{j,2},puzzle(k).edge{m,1},puzzle(k).edge{m,2});
%                         skew         = compareEgg3D(sig1,sig2);
%                     else
%                         [sig2, sig1] = RedistributePointsSig(puzzle(k).edge{m,1},puzzle(k).edge{m,2},puzzle(h).edge{j,1},puzzle(h).edge{j,2});
%                         skew         = compareEgg3D(sig1,sig2);
%                     end
                end
                
                if skew<1
                    rigidTransformation = PutTogetherAdvanced2(puzzle(h).edge{j,4},puzzle(k).edge{m,4},puzzle(h).piece,puzzle(k).piece,puzzle(h).edge{j,5},puzzle(k).edge{m,5});
                    if rigidTransformation=='w'
                        skew = 10;                     
                    end
                end
                
                cnt                        = cnt+1;
                puzzle(h).edge{j,3}(cnt,1) = skew;
                puzzle(h).edge{j,3}(cnt,2) = k;
                puzzle(h).edge{j,3}(cnt,3) = m;
                
                if (h<k)
                    num               = num+1;
                    skewMatrix(num,1) = skew;
                    skewMatrix(num,2) = h;
                    skewMatrix(num,3) = j;
                    skewMatrix(num,4) = k;
                    skewMatrix(num,5) = m;
                end
            end
        end
        puzzle(h).edge{j,3} = sortrows(puzzle(h).edge{j,3},1);
    end
end

skewMatrix = sortrows(skewMatrix,1);

%CREATING SOLUTION STRUCTURE
for h=1:length(x)
    sol(h).pieces=h; sol(h).match=[];
    if (isempty(puzzle(h).edge)==0)
        for i=1:length(puzzle(h).edge(:,1))
            sol(h).edge{i,1} = zeros(1,2);
            sol(h).edge{i,2} = zeros(1,2);
        end
    end
end

%%%%%%%%%%%%%%%%%%%%%%%%
%%% GENERAL ASSEMBLY %%%
%%%%%%%%%%%%%%%%%%%%%%%%
fprintf('GENERAL SOLVE\n');

threshold          = 0.1;
thresholdIncrement = 0.025;
clusters           = cell(1,1);
moved              = zeros(length(x),1);
solved             = 0;

%GENERAL SOLVE
for V=1:25
    if solved==1
        break
    end
    %SEARCHING FOR MATCHES
    for h=1:length(puzzle)
        %CHECKING IF PUZZLE IS SOLVED
        if sum(moved)>0
            if length(clusters{2,1})==length(puzzle)
                solved = 1;
                break
            end
        end
        
        %DETERMINING TRIAL EDGE
        p1 = h;
        if isempty(puzzle(p1).edge)
            continue
        end
        for i=1:length(puzzle(p1).edge(:,1)) %GOING THROUGH EDGES
            if (sol(p1).edge{i,1}(1,1)==0)
                for j=1:length(puzzle(p1).edge{i,3}(:,1)) %GOING THROUGH SIMILARITY SCORES
                    if puzzle(p1).edge{i,3}(j,1)>threshold || puzzle(p1).edge{i,3}(j+1,1)<threshold+thresholdIncrement
                        break
                    end

                    e1  = i;
                    e2  = puzzle(p1).edge{i,3}(j,3);
                    p2  = puzzle(p1).edge{i,3}(j,2);
                    
                    %CHECKING IF OTHER PIECE HAS BEEN SOLVED
                    if sol(p2).edge{e2,1}(1)~=0
                        continue
                    end
                                        
                    %CHECKING IF OTHER PIECE HAS MULTIPLE GOOD MATCHES
                   cnt    = 1;
                    update = 1;
                    while puzzle(p2).edge{e2,3}(cnt,2)~=p1 && puzzle(p2).edge{e2,3}(cnt,3)~=e1
                        cnt = cnt+1;
                    end
                    
                    if cnt==1 
                        closePiece = puzzle(p2).edge{e2,3}(2,2);
                        closeEdge  = puzzle(p2).edge{e2,3}(2,3);
                        if puzzle(p2).edge{e2,3}(2,1)<threshold && sol(closePiece).edge{closeEdge,1}(1)==0
                            update = 0;
                        end
                    elseif cnt>1 
                        closePiece1 = puzzle(p2).edge{e2,3}(cnt-1,2);
                        closeEdge1  = puzzle(p2).edge{e2,3}(cnt-1,3);
                        closePiece2 = puzzle(p2).edge{e2,3}(cnt+1,2);
                        closeEdge2  = puzzle(p2).edge{e2,3}(cnt+1,3);
                        
                        if puzzle(p2).edge{e2,3}(cnt-1,1)<threshold+thresholdIncrement  && sol(closePiece1).edge{closeEdge1,1}(1)==0
                            update = 0;
                        elseif puzzle(p2).edge{e2,3}(cnt+1,1)<threshold+thresholdIncrement && sol(closePiece2).edge{closeEdge2,1}(1)==0
                            update = 0;
                        end
                    end
                    
                    %UPDATE SOLUTION STRUCTURE
                    if update==1
                        sol(p1).edge{e1,1}(1,1) = p1;   sol(p2).edge{e2,1}(1,1) = p2;
                        sol(p1).edge{e1,1}(1,2) = e1;   sol(p2).edge{e2,1}(1,2) = e2;
                        sol(p1).edge{e1,2}(1,1) = p2;   sol(p2).edge{e2,2}(1,1) = p1;
                        sol(p1).edge{e1,2}(1,2) = e2;   sol(p2).edge{e2,2}(1,2) = e1;
                        sol(p1).match(end+1)    = p2;   sol(p2).match(end+1)    = p1;
                    end
                    break %BECAUSE THE EDGE IS A MATCH
                end
            else
                continue %BECAUSE PIECE ALREADY HAS A SOLUTION
            end
        end
    end
    
    % GENERAL ASSEMBLY
    if skewMatrix(1)<threshold
        [puzzle,sol,moved,clusters] = AssemblyRevise(puzzle,sol,moved,clusters);
        [puzzle,sol,temp]           = UpdateSolution(puzzle,sol,clusters);
        clear clusters
        clusters                    = temp;
    end
    
    threshold = threshold+thresholdIncrement;
    
    figure(2); hold on
    for i=1:length(x)
        if isempty(sol(i).match)==0
            plot3(puzzle(i).piece(:,1), puzzle(i).piece(:,2),puzzle(i).piece(:,3),'LineWidth',2);
        end
    end
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%  SUBPUZZLE ASSEMBLY %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf('SUBPUZZLE ASSEMBLY');

%DELETING DUPLICATES
for h=1:length(puzzle)
    sol(h).match = unique(sol(h).match);
end

%ADDING UNMATCHED PIECES AS THEIR OWN CLUSTER
for h=1:length(puzzle)
    if isempty(sol(h).match)
        clusters{length(clusters)+1,1} = h;
    end
end

for h=2:length(clusters)
    clusters{h,2} = length(puzzle)-length(clusters{h,1});
end

clusters{1,2} = length(puzzle);
clusters      = sortrows(clusters,2);

%DETERMINING SUBPUZZLE CLUSTERS
if solved==0
    for h=length(clusters):-1:2 %CLUSTER WE ARE LOOKING TO MATCH TO ANOTHER CLUSTER  (SMALL->BIG)
        if isempty(clusters{h,1})
            continue
        end
        cluster  = [];
        cluster  = clusters{h,1};
        for p=(h-1):-1:1     %CLUSTER WE ARE LOOKING INTO
            
            if p==h
                continue
            end
            
            %SEARCHING FOR BEST MATCH BETWEEN CLUSTERS
            for i=1:length(skewMatrix(:,1))
                if skewMatrix(i,1)>1
                    break
                end
                match    = 0;
                if ismember(skewMatrix(i,2),clusters{h,1}) && ismember(skewMatrix(i,4),clusters{p,1}) && skewMatrix(i,1)<1
                    match               = 1;
                    rigidTransformation = PutTogetherAdvanced(puzzle(skewMatrix(i,4)).edge{skewMatrix(i,5),4},puzzle(skewMatrix(i,2)).edge{skewMatrix(i,3),4}, ...
                        puzzle(skewMatrix(i,4)).piece, puzzle(skewMatrix(i,2)).piece,puzzle(skewMatrix(i,4)).edge{skewMatrix(i,5),5},puzzle(skewMatrix(i,2)).edge{skewMatrix(i,3),5});
                elseif ismember(skewMatrix(i,4),clusters{h,1}) && ismember(skewMatrix(i,2),clusters{p,1}) && skewMatrix(i,1)<1
                    match               = 1;
                    rigidTransformation = PutTogetherAdvanced(puzzle(skewMatrix(i,2)).edge{skewMatrix(i,3),4},puzzle(skewMatrix(i,4)).edge{skewMatrix(i,5),4}, ...
                        puzzle(skewMatrix(i,2)).piece, puzzle(skewMatrix(i,4)).piece,puzzle(skewMatrix(i,2)).edge{skewMatrix(i,3),5},puzzle(skewMatrix(i,4)).edge{skewMatrix(i,5),5});
                end
                
                %CALCULATING RIGID TRANSFORMATION MATRIX
                if match==1
                    if (rigidTransformation~='w')
                        rotation    = rigidTransformation(1:3,1:3);
                        translation = rigidTransformation(1:3,4);
                        
                        for j=1:length(cluster)
                            for k=1:length(puzzle(cluster(j)).piece(:,1))
                                puzzle(cluster(j)).piece(k,:) = (rotation*(puzzle(cluster(j)).piece(k,:))'+translation)';
                            end
                            for k=1:length(puzzle(cluster(j)).edge(:,1))
                                for l=1:length(puzzle(cluster(j)).edge{k,1}(:,1))
                                    puzzle(cluster(j)).edge{k,1}(l,:) = (rotation*(puzzle(cluster(j)).edge{k,1}(l,:))'+translation)';
                                end
                                for l=1:length(puzzle(cluster(j)).edge{k,4}(:,1))
                                    puzzle(cluster(j)).edge{k,4}(l,:) = (rotation*(puzzle(cluster(j)).edge{k,4}(l,:))'+translation)';
                                end
                            end
                        end
                        break
                    else
                        continue
                    end
                end
            end
        end
    end
end

figure(3); hold on
for i=1:length(x)
    if isempty(sol(i).match)==0
        plot3(puzzle(i).piece(:,1), puzzle(i).piece(:,2),puzzle(i).piece(:,3),'LineWidth',2);
    end
end


out=puzzle;

end
%% PROBLEMS

%THERE MIGHT BE A PROBLEM WITH ASSEMBLYING UNMOVED PIECES TO MOVED PIECES

% UPDATE MOVED AFTER SOLUTION UPDATE
% CHECK ADJACENT EDGES, IF MATCHING EDGES ARE SAME PIECE