%INPUT: Puzzle piece in the form of a nx3 matrix
%FUNCTION: Applies random 3D rigid motion to each puzzle piece
%OUTPUT: Rigidly transformed orginial puzzle piece


function out=scrambler3d(piece)

theta1=rand*2*pi;
for i=1:length(piece)
    r=[1,0,0;0,cos(theta1),-sin(theta1);0,sin(theta1),cos(theta1)];
    piece(i,:)=(r*(piece(i,:))')';
end
theta2=rand*2*pi;
for i=1:length(piece)
    r=[cos(theta2),0,sin(theta2);0,1,0;-sin(theta2),0,cos(theta2)];
    piece(i,:)=(r*(piece(i,:))')';
end
theta3=rand*2*pi;
for i=1:length(piece)
    r=[cos(theta3),-sin(theta3),0;sin(theta3),cos(theta3),0;0,0,1];
    piece(i,:)=(r*(piece(i,:))')';
end
out=piece;
end