function matout=PutTogether(curve1,curve2,piece1,piece2)

%CHECKING LENGTH OF CURVES
skip=0;
if length(curve1)~=length(curve2)
    if abs(length(curve1)-length(curve2))<20
        if length(curve1)>length(curve2)
            while length(curve1)~=length(curve2)
                curve1(end,:)=[];
            end
        else
            while length(curve1)~=length(curve2)
                curve2(end,:)=[];
            end
        end
    else
        skip=1; mat='w';
    end
end

%CALCULATING TRANSFORMATION MATRICES
if skip==0
    %TRANSFORMATION MATRICES
    rot1 = estimateRigidTransform(curve1',fliplr(curve2'));
    r1   = rot1(1:3,1:3);
    t1   = rot1(1:3,4);
    
    %ROTATING PIECE
    p2a = zeros(length(piece2),3);
    for a=1:length(piece2)
        p2a(a,:) = (r1*(piece2(a,:))'+t1)';
    end
    
    c1=zeros(length(curve2),3);
    for j=1:length(curve2(:,1))
        c1(j,:) = (r1*(curve2(j,:))'+t1)';
    end
end

%DETERMINING OUTPUT
if skip==1
    matout=mat;
else
    matout=rot1;
end

% %PLOTTING PIECES
% figure(1); hold on
% plot3(piece1(:,1),piece1(:,2),piece1(:,3));
% plot3(p2a(:,1),p2a(:,2),p2a(:,3));
% 
% figure(2); hold on
% plot3(piece1(:,1),piece1(:,2),piece1(:,3));
% plot3(p2b(:,1),p2b(:,2),p2b(:,3));
end
